#ifndef TESTCLASS_H_
#define TESTCLASS_H_

#include "iopclib/iopcHeaders.h"

using namespace iopc;

class Person : public OidObject {
public:
	EString name;
	EInt age;

public:
	Person() {};
	Person(EString name, EInt age) : name(name), age(age) {};

	virtual void write() { std::cout << name << ", " << age << std::endl; }

	static void iopcInit(iopc::Type& t) {
		t.getAttribute("name")["db.column"] = "full_name";
		t.getAttribute("name")["db.type.length"] = 200;
	}

	friend class iopc::TypeDesc<Person>;
};

class Student : public Person  {
private:
	iopc::EString school;

public:
	Student() {};
	Student(EString name, EInt age, EString school) : Person(name, age), school(school) {};

	virtual void write() { Person::write(); std::cout << "School: " << school; }

	static void iopcInit(iopc::Type& t) {
		t["db.mapping.type"] = "filtered";
		t["db.mapping.insertto"] = "::Person";
		t.getAttribute("school")["db.type.length"] = 1000;
	}

	friend class iopc::TypeDesc<Student>;
};


#endif /*TESTCLASS_H_*/
