/**
 * @file util.h
 *
 * @author Petr Cermak
 */

#ifndef UTIL_H_
#define UTIL_H_

#include <map>
#include <string>
#include <vector>
#include "defs.h"

namespace iopc {

#define IOPC_PARAM_DELIMITER ";"

class DLL_EXTERNAL StringUtil {

public:
	static int splitString(const std::string& input, const std::string& delimiter, std::vector<std::string>& results, bool skipEmpty = false);

	static std::string joinStrings(std::vector<std::string> strings, const std::string& delimiter);

	static std::map<std::string, std::string> createParamMap(const std::string& paramStr);

	static std::string join(const char* string1, const char* string2);

	static inline std::string removeFileExt(std::string fileName) {
		return fileName.substr(0, fileName.find_last_of('.'));
	}

	static int parseInt(const std::string& input);

	static bool parseBool(const std::string& input);

	static std::string toString(int i);

};

class DLL_EXTERNAL Util {
public:
	static std::string currentTime();
};

}

#endif /*UTIL_H_*/
