/**
 * @file connectionImpl.h
 * 
 * @author Petr Cermak
 */

#ifndef CONNECTIONIMPL_H_
#define CONNECTIONIMPL_H_

#include "cursorImpl.h"
#include "iopccommon/defs.h"

namespace iopc {

class DLL_EXTERNAL ConnectionImpl {
public:
	virtual void returnCursor(CursorImpl* cur) = 0;	
	virtual void commit() = 0;
	virtual void rollback() = 0;
	virtual void savepoint(const std::string& name) = 0;
	virtual void rollbackToSavepoint(const std::string& name) = 0;
	virtual void open() = 0;
	virtual void close() = 0;
	virtual void setAutoCommit(bool ac) = 0;
	virtual CursorImpl* getCursor(const std::string& sqlCommand) = 0;
	
	virtual ~ConnectionImpl() {};
};
	
}

#endif /*CONNECTIONIMPL_H_*/
