/**
 * @file iopcdb.h
 *
 * @author Petr Cermak
 */

#ifndef IOPCDB_H_
#define IOPCDB_H_

#include "iopccommon/trace.h"

namespace iopc {


class MetadataInitializer;

class IopcDb {

	public:

		static void init(
				bool initDependencies = true,
				int traceMaskTTY = LogWriter::defaultTraceMaskTTY,
				int traceMask = LogWriter::defaultTraceMask,
				const std::string& logFileName = LogWriter::defaultFileName);
		static void init(
				MetadataInitializer* metadataInitializer,
				bool initDependencies = true,
				int traceMaskTTY = LogWriter::defaultTraceMaskTTY,
				int traceMask = LogWriter::defaultTraceMask,
				const std::string& logFileName = LogWriter::defaultFileName);

		static void shutdown(bool shutdownDependencies = true);

};


}

#endif /* IOPCDB_H_ */
