#ifndef CACHELOCK_H_
#define CACHELOCK_H_

#include "iopccommon/defsPlatform.h"
#include "../databaseObject.h"

namespace iopc {

/** 
 * @brief Locks object in the cache and returns a pointer to it.
 * 
 * Locks can be added and removed.
 */
class DLL_EXTERNAL CacheLock {
	
public:
	/** Returns the object. */
	virtual DatabaseObject& getObject() = 0;
	
	/** 
	 * @brief Adds lock to the object.
	 * @param rdonly Specifies type of lock to be added.
	 * 
	 * @return An instance representing new lock.
	 */
	virtual CacheLock& addLock(bool rdonly) = 0;
	
	/** Removes one lock. */
	virtual void rmLock() = 0;
	
	virtual ~CacheLock() {} ;
};

}

#endif /*CACHELOCK_H_*/
