#include "extendedCache.h"

namespace iopc {

bool ExtendedCache::imposeLimits(long minValue, long maxCost)
{
	TimeStamp now = TimeStamp::now();
	Strategy strat = stratSel != NULL ? stratSel->select() : defaultStratSel.select();
	long costChange;
	while (getWorstValue(now) < minValue || getActiveCost() + getLockedCost() > maxCost) {
		costChange = removeWorst();
		if (costChange != 0) {
			strat.wakeUpMaintainer(costChange);
		} else {
			break;
		}
	}
	if (!strat.hasMaintainer()) {
		while (maintainerStep(costChange));
	}
	return getWorstValue(now) >= minValue &&  getActiveCost() + getLockedCost() <= maxCost;
}

}/*namespace polite*/
