#ifndef MAPPINGSTATEMENTSFEATURE_H_
#define MAPPINGSTATEMENTSFEATURE_H_

#include "iopcdb/dbFeature.h"
#include "iopccommon/metadataHolder.h"
#include "../types/dbType.h"
#include <vector>

namespace iopc {

class Type;

class MappingStatementsFeature : public DbFeature
{
private:
	static std::string featureName;
public:
	virtual const std::string& getNameInst() {
		return getName();
	}
	
	static const std::string& getName() {
		return featureName;
	}
	
	// interface
	
	virtual std::string getSelectTypeStatement(const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::string getSelectSerialIdStatement(const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;	
	virtual std::string getNextOidStatement(const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::string getNextSerialIdStatement(const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::vector<std::string> dbCreateScriptStart(const MetadataHolder& attributes = MetadataHolder::emptyMeta) =0;
	virtual std::vector<std::string> dbCreateScriptEnd(const MetadataHolder& attributes = MetadataHolder::emptyMeta) =0;
	virtual std::vector<std::string> dbDropScriptStart(const MetadataHolder& attributes = MetadataHolder::emptyMeta) =0;
	virtual std::vector<std::string> dbDropScriptEnd(const MetadataHolder& attributes = MetadataHolder::emptyMeta) =0;
	virtual std::vector<std::string> getCreateClassTableScript(const DbType& dbType, const MetadataHolder& attributes = MetadataHolder::emptyMeta) =0;
	
	virtual std::vector<std::string> getCreateUpDownViewsScript(const DbType& dbType, const MetadataHolder& attributes = MetadataHolder::emptyMeta) =0;
	virtual std::vector<std::string> getCreateDownUpViewsScript(const DbType& dbType, const MetadataHolder& attributes = MetadataHolder::emptyMeta) =0;
	virtual std::vector<std::string> getDropClassTableScript(const DbType& dbType, const MetadataHolder& attributes = MetadataHolder::emptyMeta) =0;
	virtual std::vector<std::string> getDropUpDownViewsScript(const DbType& dbType, const MetadataHolder& attributes = MetadataHolder::emptyMeta) =0;
	virtual std::vector<std::string> getDropDownUpViewsScript(const DbType& dbType, const MetadataHolder& attributes = MetadataHolder::emptyMeta) =0;
	
	virtual std::string getQueryStatement(const DbType& dbType, const MetadataHolder& attributes) =0; 
};


}


#endif /*MAPPINGSTATEMENTSFEATURE_H_*/
