#ifndef ORSTATEMENTSFEATURE_H_
#define ORSTATEMENTSFEATURE_H_

#include "iopcdb/dbFeature.h"
#include "iopccommon/metadataHolder.h"
#include "../types/dbType.h"
#include "iopccommon/rwLock.h"
#include "../types/orMappingStrategy.h"
#include <vector>

namespace iopc {

class Type;

class ORStatementsFeature : public DbFeature
{
private:
	static std::string featureName;
public:
	virtual const std::string& getNameInst() {
		return getName();
	}
	
	static const std::string& getName() {
		return featureName;
	}
	
	// interface
	virtual std::string getSelectFromClassViewStatement(ORMappingStrategy& currentStrategy, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::string getSelectFromClassTableStatement(ORMappingStrategy& currentStrategy, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::string getInsertStatement(ORMappingStrategy& currentStrategy, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::string getUpdateStatement(ORMappingStrategy& currentStrategy, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::string getUpdateStatement(ORMappingStrategy& currentStrategy, const ORMappingStrategy::MappedAttributesList& updateCols, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::string getDeleteStatement(ORMappingStrategy& currentStrategy, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual bool validate(ORMappingStrategy& currentStrategy, std::string& msg) =0;
};


}




#endif /*ORSTATEMENTSFEATURE_H_*/
