#ifndef FREEQUERY_H_
#define FREEQUERY_H_

#include "query.h"

namespace iopc {
	
	
class Type;
class Connection;
class Driver;

class DLL_EXTERNAL FreeQuery : public Query {

private:
	std::string query;
	std::string prefix;
	bool useViewColumns;

public:
	FreeQuery(std::string queryStr, const std::string& prefix = "", bool useViewColumns = true) : query(queryStr), prefix(prefix), useViewColumns(useViewColumns) {};
	//FreeQuery(std::string queryStr, const std::string& prefix) : query(queryStr), prefix(prefix), useViewColumns(true) {};
	//FreeQuery(std::string queryStr, bool useViewColumns) : query(queryStr), prefix(""), useViewColumns(useViewColumns) {};
	FreeQuery(const FreeQuery& query) : query(query.query), prefix(query.prefix), useViewColumns(useViewColumns) {};
	
	virtual std::string getSql(Driver& drv, const Type& type) const;
	
protected:
	virtual Query* clone() const;

	
};

	
	
	
	
	
	
	
}


#endif /*FREEQUERY_H_*/
