#ifndef OIDOBJECT_H_
#define OIDOBJECT_H_

#include "databaseObject.h"
//#include <iostream>

namespace iopc {

typedef EULong OidType;
typedef unsigned long OidTypeInner;
typedef EULong SerialIdType;

class DLL_EXTERNAL OidObject : public DatabaseObject {

private:
	static void iopcInit(iopc::Type& t) {
		if (!t.hasMeta("db.table")) {
			t["db.table"] = "OidObject";
		}
		//t.getAttribute("oid")["db.sequence"] = "OIDSEQ";
		const Attribute& aOid = t.getAttribute("oid");
		if (!aOid.hasMeta("db.column")) {
			aOid["db.column"] = "OID";
		}
		t.getAttribute("oid")["db.primaryKey"].setBoolValue(true);
		if (!aOid.hasMeta("db.viewColumn")) {
			aOid["db.viewColumn"] = "OID";
		}
		const Attribute& aClassName = t.getAttribute("className");
		if (!aClassName.hasMeta("db.column")) {
			aClassName["db.column"] = "CLASSNAME";
		}
		if (!aClassName.hasMeta("db.type.length")) {
			aClassName["db.type.length"] = 1000;
		}
		if (!aClassName.hasMeta("db.viewColumn")) {
			aClassName["db.viewColumn"] = "CLASSNAME";
		}
		if (!aClassName.hasMeta("db.index")) {
			aClassName["db.index"] = "idxcn";
		}
		const Attribute& aSerialId = t.getAttribute("serialId");
		if (!aSerialId.hasMeta("db.column")) {
			aSerialId["db.column"] = "SERIALID";
		}
		if (!aSerialId.hasMeta("db.viewColumn")) {
			aSerialId["db.viewColumn"] = "SERIALID";
		}
	}

protected:
	void onIopcCreate();

public:
	OidType oid;
	EString className;
	SerialIdType serialId;

	virtual void onCreate() {};
	//virtual void onLoad() {};
	// TODO: create remaining events.. onCacheDelete etc...


	inline virtual bool isDatabaseObject() {
		return true;
	};

	inline virtual bool isOidObject() {
		return true;
	};

	virtual ~OidObject() {};


	friend class DbPtrBase; // onIopcCreate();
	friend class TypeDesc<OidObject>;
};

// TypeDesc for OidType

}

// generate TypeDesc
META_BLOCK1(iopc::OidObject)
META_PARENT1(iopc::DatabaseObject)
META_ATTR1(oid, OidType, Attribute::VISIBILITY_PUBLIC)
META_ATTR1(className, EString, Attribute::VISIBILITY_PUBLIC)
META_ATTR1(serialId, SerialIdType, Attribute::VISIBILITY_PUBLIC)
META_BLOCK2(iopc::OidObject)
META_ATTR2(iopc::OidObject, oid)
META_ATTR2(iopc::OidObject, className)
META_ATTR2(iopc::OidObject, serialId)
META_BLOCK3(iopc::OidObject, OidObject, iopc)
META_INIT(iopc::OidObject)
META_BLOCK4


/*
namespace iopc {
template <> class TypeDesc< iopc::OidObject> : public Type {
public:
	TypeDesc<  iopc::OidObject>() {
		parentsTypeInfo.push_back(&typeid(DatabaseObject));
		attributes.insert(std::make_pair("oid", Attribute("oid", TypeDesc< OidType>::getType(), Attribute::VISIBILITY_PUBLIC, *this)));
		attributes.insert(std::make_pair("className", Attribute("className", TypeDesc< EString>::getType(), Attribute::VISIBILITY_PUBLIC, *this)));
		attributes.insert(std::make_pair("serialId", Attribute("serialId", TypeDesc< SerialIdType>::getType(), Attribute::VISIBILITY_PUBLIC, *this)));
	}
	inline virtual void fillAttributeValues(const Object& o, std::map<std::string, AttributeValue>& out) const {
		for(std::map<std::string, Attribute>::const_iterator it = attributes.begin(); it != attributes.end(); it++) {
			std::string attrName = (*it).first;

			if (attrName == "oid") { std::cout << std::string("attr: ") << attrName << " " << reinterpret_cast<uint> ((void*)&dynamic_cast<const iopc::OidObject&>(o).oid) << std::endl; out.insert(std::make_pair(attrName, AttributeValue((*it).second, &dynamic_cast<const iopc::OidObject&>(o).oid))); continue; }
			if (attrName == "className") { std::cout << std::string("attr: ") << attrName << " " << reinterpret_cast<uint> ((void*)&dynamic_cast<const iopc::OidObject&>(o).className) << std::endl; out.insert(std::make_pair(attrName, AttributeValue((*it).second, &dynamic_cast<const iopc::OidObject&>(o).className))); continue; }
			if (attrName == "serialId") { std::cout << std::string("attr: ") << attrName << " " << reinterpret_cast<uint> ((void*)&dynamic_cast<const iopc::OidObject&>(o).serialId) << std::endl; out.insert(std::make_pair(attrName, AttributeValue((*it).second, &dynamic_cast<const iopc::OidObject&>(o).serialId))); continue; }
		}
	}

	virtual ~TypeDesc< iopc::OidObject>() {};
	static inline const TypeDesc< iopc::OidObject>& getType() {static TypeDesc< iopc::OidObject> instance; return instance; };
	virtual void* newInstance() const { return new iopc::OidObject(); };
	virtual Object* newObjectInstance() const { return dynamic_cast<Object*>((iopc::OidObject*) new iopc::OidObject()); }
	inline virtual DataTypeClassEnum getDataTypeClass() const { return IOPC_TYPECLASS_COMPLEX; }
	inline virtual DataTypeEnum getDataType() const { return IOPC_TYPE_COMPLEX; };
	virtual int getSizeOf(const void* object) const { return sizeof(iopc::OidObject); };
	virtual const std::string getName() const{return "OidObject";};
	virtual const std::string getNamespace() const {return "iopc";};
	inline virtual bool isBuiltIn() const { return false; };
	//inline virtual const std::map<std::string, Attribute>& getAttributes() const { return attributes; };
	virtual void iopcInit() { iopc::OidObject::iopcInit(*this); }
};
}*/






#endif /*OIDOBJECT_H_*/
