#ifndef QUERY_H_
#define QUERY_H_

#include <string>
#include "iopccommon/defs.h"

#define TYPE_DELIMITER "$"

namespace iopc {

/**
 * @brief Represents a unique identifier of a persistent object.
 */

class Type;
class Connection;
class Driver;

class DLL_EXTERNAL Query {
public:


	virtual std::string getSql(Driver& drv, const Type& type) const =0;

	const std::string typeDelimiter;

	virtual ~Query() {};

	virtual Query* clone() const =0;

protected:
	std::string substituteQuery(std::string query, const Type& type, bool useSV = false) const;

	Query() {};

};

}

#endif /*QUERY_H_*/
