#ifndef RESULTBASE_H_
#define RESULTBASE_H_

#include <string>
#include <vector>
#include "query.h"

namespace iopc {
class CachedConnection;
class DbType;
class Type;


class DLL_EXTERNAL ResultBase{
protected:
	CachedConnection* conn;
	const Query* query;
	bool isTransient;	
	bool preload;	
private:
	const Type& type;
	DbType& dbType;
	
	Cursor* cur;
	KeyValues fetchedKey;
	std::vector<KeyValues> keys;
	
public:
	ResultBase(CachedConnection* conn, const Query& query, bool preload, const Type& type);
	virtual ~ResultBase();
	
	inline const Query& getQuery() { return *query; }
	
	void open();
	
	bool fetchNext();
	
	bool fetchPrev();
	
	void close();

protected:
	KeyValues getCurrentKey();
	KeyValues getKeyAt(int i);
	inline int getKeyCount() { return keys.size(); }
	virtual bool loadCurrentObject(Cursor& cur) =0;
	
};

}

#endif /*RESULTBASE_H_*/
