#ifndef SIMPLEQUERY_H_
#define SIMPLEQUERY_H_

#include <string>
#include "iopccommon/defs.h"
#include "query.h"

namespace iopc {

/**
 * @brief Represents a unique identifier of a persistent object.
 */

class Type;
class Connection;
class Driver;

class DLL_EXTERNAL SimpleQuery : public Query {
private:
	std::string query;
	bool all;
	std::string sort;

public:

	static SimpleQuery All;

	SimpleQuery(std::string queryStr = "", std::string sortStr = "") : query(queryStr), all(queryStr == ""), sort(sortStr) {};
	SimpleQuery(const SimpleQuery& query) : query(query.query), all(query.all), sort(query.sort) {};

	virtual std::string getSql(Driver& drv, const Type& type) const;

protected:
	virtual Query* clone() const;

};

}

#endif /*SIMPLEQUERY_H_*/
