#ifndef DBTYPEMANAGER_H_
#define DBTYPEMANAGER_H_

#include <map>
#include "iopcmeta/type.h"
#include "dbType.h"
#include "iopccommon/lock.h"
#include "iopccommon/rwxLock.h"


namespace iopc {

class Driver;

/*class StaticSqlStatements {
public:
	std::string selectTypeStatement;
	std::string getNextOidStatement;
	std::string getNextSerialIdStatement;
	std::string selectSerialIdStatement;
};
*/
class DbTypeManager {
public:

	typedef std::map<const Type*, DbType> DbTypesMap;
	typedef DbTypesMap::const_iterator DbTypesIterator;

	static inline DbType& getDbType(const Type& t) {
		return getInstance().getDbTypeInst(t);
	}
	static inline DbType& getDbTypeWithInit(const Type& t) {
		DbType& dbType = getInstance().getDbTypeInst(t);
		dbType.init(t);
		return dbType;
	}
	
	static inline DbTypesMap& getDbTypesMap() {
		return getInstance().getDbTypesMapInst();
	}
	inline DbTypesMap& getDbTypesMapInst() {
		return dbTypes;
	}
	
	static inline void init() {
		getInstance().initInst();
	}

	static DbTypeManager& getInstance();
	
	void initInst();
	DbType& getDbTypeInst(const Type& t);
	
	// SQL
	
	const Type& getTypeInst(Connection& conn, const OidType oid);
	OidType getNextOidInst(Connection& conn);
	SerialIdType getNextSerialIdInst(Connection& conn);
	SerialIdType getSerialIdInst(Connection& conn, const OidType oid);
	
	static inline const Type& getType(Connection& conn, const OidType oid) {
		return getInstance().getTypeInst(conn, oid);
	}
	static inline const OidType getNextOid(Connection& conn) {
		return getInstance().getNextOidInst(conn);
	}
	static inline const SerialIdType getNextSerialId(Connection& conn) {
		return getInstance().getNextSerialIdInst(conn);
	}
	static inline const SerialIdType getSerialId(Connection& conn, const OidType oid) {
		return getInstance().getSerialIdInst(conn, oid);
	}
	
	typedef std::vector<Driver*> DriversList;
	typedef DriversList::const_iterator DriversIterator;	
		
	static inline const DriversList& getORDrivers() { return getInstance().getORDriversInst(); }
	inline const DriversList& getORDriversInst() const { return driversList;}
	
private:


	//void initSql();
	
	//std::map<Driver*, StaticSqlStatements> sqlStatements;
	DbTypesMap dbTypes;
	
	//Lock lock;
	
	DbTypeManager();
	~DbTypeManager();
	
	DriversList driversList;
	
};
	
}


#endif /*DbTypeManager_H_*/
