#ifndef ATTRIBUTEVALUE_H_
#define ATTRIBUTEVALUE_H_

#include "iopccommon/defs.h"
#include "attribute.h"
#include <string>

namespace iopc {

class Type;

class DLL_EXTERNAL AttributeValue {
public:	
	AttributeValue(const Attribute& attr, const void* value) : attribute(&attr), value(const_cast<void*>(value)) {};
	AttributeValue(const AttributeValue& src) : attribute(src.attribute), value(src.value) {};

	inline const Attribute& getAttribute() const { return *attribute; };
	inline void* getValue() const { return value; };
	
	inline AttributeValue& operator=(const AttributeValue& src)  { attribute = src.attribute; value = src.value; return *this; }
	inline bool operator!=(const AttributeValue& src) const { return this != &src; }
	inline bool operator==(const AttributeValue& src) const { return this == &src; }
	inline bool operator<(const AttributeValue& src) const { return this < &src; }
private:
	const Attribute* attribute;
	void* value;
};

}



#endif /*ATTRIBUTEVALUE_H_*/
