/**
 * @file iopcMommon.cpp
 *
 * @author Petr Cermak
 */

#include "iopcMeta.h"
#include "typeManager.h"
#include "iopccommon/iopcCommon.h"

namespace iopc {

void IopcMeta::init(MetadataInitializer* metadataInitializer, int traceMaskTTY, int traceMask, const std::string& logFileName)
{
	initializer = metadataInitializer;
	init(traceMaskTTY, traceMask, logFileName);
}

void IopcMeta::init(int traceMaskTTY, int traceMask, const std::string& logFileName)
{
	IopcCommon::init(traceMaskTTY, traceMask, logFileName);
	TypeManager::init();
	if (initializer != NULL) {
		initializer->initializeMetadata();
		delete initializer;
		initializer = NULL;
	}
}


void IopcMeta::shutdown()
{
	IopcCommon::shutdown();
}


MetadataInitializer* IopcMeta::initializer = NULL;

}
