#ifndef METASUPPORT_H_
#define METASUPPORT_H_

//#include "types/dbType.h"
#include "object.h"
#include "typeDesc.h"
#include "typeRegistrar.h"
#include <typeinfo>
#include <string>
#include <map>
//#include "iopccommon/trace.h"
//#include <iostream>

#define META_BEGIN_NAMESPACE namespace iopc {
#define META_END_NAMESPACE } \

#define META_BEGIN_CLASS(qualifiedClassName) template <> class TypeDesc< qualifiedClassName> : public Type {
#define META_END_CLASS };
#define META_PUBLIC public:
#define META_PRIVATE private:
#define META_PROTECTED protected:
#define META_CONSTR_BEGIN(qualifiedClassName)  TypeDesc< qualifiedClassName>() { \
//	TypeManager::registerType(this, #qualifiedClassName);
#define META_CONSTR_PARENT(type) \
	parentsTypeInfo.push_back(&typeid(type));
#define META_CONSTR_ATTR(name, type, visibility) \
	attributes.insert(std::make_pair(#name, Attribute(#name, TypeDesc< type>::getType(), visibility, *this)));
#define META_CONSTR_END }
#define META_FILLATTR_BEGIN(qualifiedClassName) inline virtual void fillAttributeValues(const Object& o, std::map<std::string, AttributeValue>& out) const { \
		for(std::map<std::string, Attribute>::const_iterator it = attributes.begin(); it != attributes.end(); it++) { \
			std::string attrName = (*it).first;
#define META_FILLATTR_ATTR(qualifiedClassName, name) if (attrName == #name) { out.insert(std::make_pair(attrName, AttributeValue((*it).second, &dynamic_cast<const qualifiedClassName&>(o).name))); continue; }

#define META_FILLATTR_END }}
#define META_PUBLIC_BODY(qualifiedClassName, className, nameSpace)  \
	virtual ~TypeDesc< qualifiedClassName>() {}; \
	static inline const TypeDesc< qualifiedClassName>& getType() {static TypeDesc< qualifiedClassName> instance; return instance; }; \
	virtual void* newInstance() const { return new qualifiedClassName(); }; \
	virtual Object* newObjectInstance() const { return dynamic_cast<Object*>((qualifiedClassName*) new qualifiedClassName()); } \
	inline virtual DataTypeClassEnum getDataTypeClass() const { return IOPC_TYPECLASS_COMPLEX; } \
	inline virtual DataTypeEnum getDataType() const { return IOPC_TYPE_COMPLEX; }; \
	virtual int getSizeOf(const void* object) const { return sizeof(qualifiedClassName); }; \
	virtual const std::string getName() const{return #className;}; \
	virtual const std::string getNamespace() const {return #nameSpace;}; \
	inline virtual bool isBuiltIn() const { return false; }; \
	//inline virtual const std::map<std::string, Attribute>& getAttributes() const { return attributes; };
#define META_INIT(qualifiedClassName) \
	virtual void iopcInit() { qualifiedClassName::iopcInit(*this); }
#define META_PRIVATE_BODY //std::map<std::string, Attribute> attributes;

#define CAT2(X,Y) X##Y
#define CAT(X,Y) CAT2(X,Y)
#define META_REGISTER_TYPE(qualifiedClassName) \
	static iopc::TypeRegistrar<qualifiedClassName> CAT(TypeRegistrarInst_, __LINE__) ; \
	template class iopc::TypeDesc<qualifiedClassName>; \



#define META_BLOCK1(qualifiedClassName) \
META_BEGIN_NAMESPACE \
META_BEGIN_CLASS(qualifiedClassName) \
META_PUBLIC \
META_CONSTR_BEGIN(qualifiedClassName)
#define META_PARENT1(type) META_CONSTR_PARENT(type)
#define META_ATTR1(name, type, visibility) META_CONSTR_ATTR(name, type, visibility)
#define META_BLOCK2(qualifiedClassName) \
META_CONSTR_END \
META_FILLATTR_BEGIN(qualifiedClassName)
#define META_ATTR2(qualifiedClassName, name) META_FILLATTR_ATTR(qualifiedClassName, name)
#define META_BLOCK3(qualifiedClassName, className, nameSpace) \
META_FILLATTR_END \
META_PUBLIC_BODY(qualifiedClassName, className, nameSpace) \
META_PROTECTED
// META_INIT
#define META_BLOCK4 \
META_PRIVATE \
META_PRIVATE_BODY \
META_END_CLASS \
META_END_NAMESPACE


#endif /*METASUPPORT_H_*/
// #define META_FILLATTR_ATTR(qualifiedClassName, name) if (attrName == #name) { std::cout << std::string("attr: ") << attrName << " " << reinterpret_cast<uint> ((void*)&dynamic_cast<const qualifiedClassName&>(o).name) << std::endl; out.insert(std::make_pair(attrName, AttributeValue((*it).second, &dynamic_cast<const qualifiedClassName&>(o).name))); continue; }
