#ifndef DIAMOND_H_
#define DIAMOND_H_

#include "iopcmeta/metaSupport.h"
#include "iopcmeta/object.h"
#include "iopcmeta/enhancedNumber.h"
#include "iopcmeta/enhancedString.h"
//#include <iostream>
#include "iopcmeta/type.h"
#include "iopclib/oidObject.h"

class DiamondClass : public iopc::OidObject {
public:
	iopc::EString test1;
public:
	DiamondClass() {
		test1 = "value 1";
	}
	
	void test() {
		test1 = "testValue";
	}

	static void iopcInit(iopc::Type& t) {
//		t["db.mapping.oidmanaged"] = true;
		t["db.table"] = "diamond";
		//t["db.mapping.type"] = "vertical";
		t.getAttribute("test1")["db.column"] = "test";
		t.getAttribute("test1")["db.type.length"] = 10;
	}
	
	friend class iopc::TypeDesc<DiamondClass>;
};

class DiamondClass2 : public virtual DiamondClass  {
public:
	iopc::EString test2;
public:	
	DiamondClass2() {
		test2 = "value 2";
	}
	
	static void iopcInit(iopc::Type& t) {
//		t["db.mapping.oidmanaged"] = true;
		t["db.table"] = "diamond2";
		//t["db.mapping.type"] = "vertical";
		t.getAttribute("test2")["db.column"] = "test2";
		t.getAttribute("test2")["db.type.length"] = 10;
	}
	friend class iopc::TypeDesc<DiamondClass2>;
};

class DiamondClass3 : public virtual DiamondClass {
public:
	iopc::EString test3;
public:
	DiamondClass3() {
		test3 = "value 3";
	}
	
	static void iopcInit(iopc::Type& t) {
//		t["db.mapping.oidmanaged"] = true;
		t["db.table"] = "diamond3";
		t["db.mapping.type"] = "horizontal";
		t.getAttribute("test3")["db.column"] = "test3";
		t.getAttribute("test3")["db.type.length"] = 10;
	}
	friend class iopc::TypeDesc<DiamondClass3>;
};

class DiamondClass4 : public DiamondClass2, public DiamondClass3 {
public:
	iopc::EString test4;
public:	
	DiamondClass4() {
		test4 = "value 4";
	}
	
	static void iopcInit(iopc::Type& t) {
//		t["db.mapping.oidmanaged"] = true;
		t["db.table"] = "diamond4";
		//t["db.mapping.type"] = "vertical";
		t.getAttribute("test4")["db.column"] = "test4";
		t.getAttribute("test4")["db.type.length"] = 10;
	}
	friend class iopc::TypeDesc<DiamondClass4>;
};

class DiamondClass5 : public DiamondClass4 {
public:
	iopc::EString test5;
public:	
	DiamondClass5() {
		test5 = "value 5";
	}
	
	static void iopcInit(iopc::Type& t) {
//		t["db.mapping.oidmanaged"] = true;
		t["db.table"] = "diamond5";
		t["db.mapping.type"] = "filtered";
		t["db.mapping.insertto"] = "::DiamondClass";
		t.getAttribute("test5")["db.column"] = "test5";
		t.getAttribute("test5")["db.type.length"] = 10;
	}
	friend class iopc::TypeDesc<DiamondClass5>;
};

class DiamondClass6 : public DiamondClass2{
public:
	iopc::EString test6;
public:	
	DiamondClass6() {
		test6 = "value 6";
	}
	
	static void iopcInit(iopc::Type& t) {
//		t["db.mapping.oidmanaged"] = true;
		t["db.table"] = "diamond6";
		t["db.mapping.type"] = "filtered";
		t["db.mapping.insertto"] = "::DiamondClass";
		t.getAttribute("test6")["db.column"] = "test6";
		t.getAttribute("test6")["db.type.length"] = 10;
	}
	friend class iopc::TypeDesc<DiamondClass6>;
};

class DiamondClass7 : public DiamondClass6{
public:
	iopc::EString test7;
public:	
	DiamondClass7() {
		test7 = "value 7";
	}
	
	static void iopcInit(iopc::Type& t) {
//		t["db.mapping.oidmanaged"] = true;
		t["db.table"] = "diamond7";
		//t["db.mapping.type"] = "filtered";
		//t["db.mapping.insertto"] = "::DiamondClass";
		t.getAttribute("test7")["db.column"] = "test7";
		t.getAttribute("test7")["db.type.length"] = 10;
	}
	friend class iopc::TypeDesc<DiamondClass7>;
};

class DiamondClass8 : public DiamondClass7{
public:
	iopc::EString test8;
public:	
	DiamondClass8() {
		test8 = "value 8";
	}
	
	static void iopcInit(iopc::Type& t) {
//		t["db.mapping.oidmanaged"] = true;
		t["db.table"] = "diamond8";
		t["db.mapping.type"] = "object";
		//t["db.mapping.type"] = "filtered";
		//t["db.mapping.insertto"] = "::DiamondClass";
		t.getAttribute("test8")["db.column"] = "test8";
		t.getAttribute("test8")["db.type.length"] = 10;
	}
	friend class iopc::TypeDesc<DiamondClass8>;
};

class DiamondClass9 : public DiamondClass8{
public:
	iopc::EString test9;
public:	
	DiamondClass9() {
		//test9 = "value 9";
	}
	
	static void iopcInit(iopc::Type& t) {
//		t["db.mapping.oidmanaged"] = true;
		t["db.table"] = "diamond9";
		t["db.mapping.type"] = "object";
		//t["db.oracle.useOracleObjects"].setBoolValue(true);
		//t["db.mapping.type"] = "filtered";
		//t["db.mapping.insertto"] = "::DiamondClass";
		t.getAttribute("test9")["db.column"] = "test9";
		t.getAttribute("test9")["db.type.length"] = 19;
		t.getAttribute("test9")["db.index"] = "idx_test9";
	}
	friend class iopc::TypeDesc<DiamondClass9>;
};

META_BLOCK1(::DiamondClass9)
META_PARENT1(::DiamondClass8)
META_ATTR1(test9, iopc::EString, Attribute::VISIBILITY_PUBLIC)
META_BLOCK2(::DiamondClass9)
META_ATTR2(::DiamondClass9, test9)
META_BLOCK3(::DiamondClass9, DiamondClass9, )
META_INIT(::DiamondClass9)
META_BLOCK4

META_BLOCK1(::DiamondClass8)
META_PARENT1(::DiamondClass7)
META_ATTR1(test8, iopc::EString, Attribute::VISIBILITY_PUBLIC)
META_BLOCK2(::DiamondClass8)
META_ATTR2(::DiamondClass8, test8)
META_BLOCK3(::DiamondClass8, DiamondClass8, )
META_INIT(::DiamondClass8)
META_BLOCK4

META_BLOCK1(::DiamondClass7)
META_PARENT1(::DiamondClass6)
META_ATTR1(test7, iopc::EString, Attribute::VISIBILITY_PUBLIC)
META_BLOCK2(::DiamondClass7)
META_ATTR2(::DiamondClass7, test7)
META_BLOCK3(::DiamondClass7, DiamondClass7, )
META_INIT(::DiamondClass7)
META_BLOCK4

META_BLOCK1(::DiamondClass6)
META_PARENT1(::DiamondClass2)
META_ATTR1(test6, iopc::EString, Attribute::VISIBILITY_PUBLIC)
META_BLOCK2(::DiamondClass6)
META_ATTR2(::DiamondClass6, test6)
META_BLOCK3(::DiamondClass6, DiamondClass6, )
META_INIT(::DiamondClass6)
META_BLOCK4

META_BLOCK1(::DiamondClass5)
META_PARENT1(::DiamondClass4)
META_ATTR1(test5, iopc::EString, Attribute::VISIBILITY_PUBLIC)
META_BLOCK2(::DiamondClass5)
META_ATTR2(::DiamondClass5, test5)
META_BLOCK3(::DiamondClass5, DiamondClass5, )
META_INIT(::DiamondClass5)
META_BLOCK4

META_BLOCK1(::DiamondClass4)
META_PARENT1(::DiamondClass2)
META_PARENT1(::DiamondClass3)
META_ATTR1(test4, iopc::EString, Attribute::VISIBILITY_PUBLIC)
META_BLOCK2(::DiamondClass4)
META_ATTR2(::DiamondClass4, test4)
META_BLOCK3(::DiamondClass4, DiamondClass4, )
META_INIT(::DiamondClass4)
META_BLOCK4

META_BLOCK1(::DiamondClass3)
META_PARENT1(::DiamondClass)
META_ATTR1(test3, iopc::EString, Attribute::VISIBILITY_PUBLIC)
META_BLOCK2(::DiamondClass3)
META_ATTR2(::DiamondClass3, test3)
META_BLOCK3(::DiamondClass3, DiamondClass3, )
META_INIT(::DiamondClass3)
META_BLOCK4

META_BLOCK1(::DiamondClass2)
META_PARENT1(::DiamondClass)
META_ATTR1(test2, iopc::EString, Attribute::VISIBILITY_PUBLIC)
META_BLOCK2(::DiamondClass2)
META_ATTR2(::DiamondClass2, test2)
META_BLOCK3(::DiamondClass2, DiamondClass2, )
META_INIT(::DiamondClass2)
META_BLOCK4

META_BLOCK1(::DiamondClass)
META_PARENT1(iopc::OidObject)
META_ATTR1(test1, iopc::EString, Attribute::VISIBILITY_PUBLIC)
META_BLOCK2(::DiamondClass)
META_ATTR2(::DiamondClass, test1)
META_BLOCK3(::DiamondClass, DiamondClass, )
META_INIT(::DiamondClass)
META_BLOCK4


#endif /*DIAMOND_H_*/
