#ifndef TESTCASE_H
#define TESTCASE_H

#include <set>
#include <string>


#define CONNSTR "username=iopc;password=iopc"
#define DBNAME "XE"

/**
@author Petr Cermak
*/
class TestCase{
public:

	std::string name;
	TestCase(const std::string& testName, bool initTest = false, bool tearDownTest = false);
	virtual ~TestCase();

	virtual bool doTest() { return true; };

public:
	// Static methods
	static void runTests();

protected:
	static void logMsg(const std::string& msg);
	static void logMsg(const std::string& msg, const int val);
private:
	static TestCase* initTest;
	static TestCase* tearDownTest;
	static std::set<TestCase*> testCases;
	static void addTest(TestCase* tc);
	static void removeTest(TestCase* tc);

	static std::set<TestCase*>& getTestCases();
};
#define NOEXC(command) \
try {  \
	command;  \
} catch(...) {};

#endif
