#include <iostream>
#include <ostream>
#include <istream>
#include <fstream>

#include "iopccommon/trace.h"
#include "tests/logwriterTest.h"


using namespace iopc;
using namespace std;

LogWriterTest::LogWriterTest(const std::string& testName)
 : TestCase(testName)
{

}

LogWriterTest::~LogWriterTest()
{
}


bool LogWriterTest::doTest()
{
	int oldMaskTTY = LogWriter::getInstance().traceMaskTTY;
	int oldMask = LogWriter::getInstance().traceMask;
	string oldFileName = LogWriter::getInstance().fileName;
	
	const string testString = "XXYYLogTest";
	
	LogWriter::logOpen("test_log.txt", false);
	LogWriter::getInstance().traceMaskTTY = 0;    // Turn off logging on the screen
	LogWriter::getInstance().traceMask = LogWriter::INFO|LogWriter::DEBUG|LogWriter::TRACE; // Do not log ERROR
	
	IOPC_DEBUGLOG(testString); //1
	IOPC_FUNC_INVOKED;
	IOPC_FUNC_END("XXYYLogTest"); //2
	
	LogWriter::logInfo(testString); //3
	LogWriter::logError(testString);	// Should be filtered

	LogWriter::getInstance().logFlushInst();

	
	ifstream input(LogWriter::getInstance().fileName.c_str());
	string str;
	int count = 0;
	while (getline(input, str)) {
		if (str.find(testString) != string::npos) {
			count++;
		}
	}
	
	LogWriter::logOpen(oldFileName, true);
	LogWriter::getInstance().traceMaskTTY = oldMaskTTY;
	LogWriter::getInstance().traceMask = oldMask;
	
	return count == 3;
}

static LogWriterTest logWriterTestInstance("Trace - Log writer");
